## simgrid 4.1

=== CMakeLists.txt ===
# Build the version number

set(SIMGRID_VERSION_MAJOR "4")
set(SIMGRID_VERSION_MINOR "1")
set(SIMGRID_VERSION_PATCH "0") # odd => git branch; even => stable release or released snapshot

if(${SIMGRID_VERSION_PATCH} EQUAL "0")
  set(release_version "${SIMGRID_VERSION_MAJOR}.${SIMGRID_VERSION_MINOR}")
else()
  set(release_version "${SIMGRID_VERSION_MAJOR}.${SIMGRID_VERSION_MINOR}.${SIMGRID_VERSION_PATCH}")
endif()

if(WIN32 OR MINGW)
  message(FATAL_ERROR "SimGrid does not build on native windows, nor with MinGW. Please use WSL2 instead.")
endif()

message(STATUS "Configuring SimGrid v${release_version}")

set(SIMGRID_VERSION_STRING "SimGrid version ${release_version}")

set(libsimgrid_version "${release_version}")
set(libsimgrid-java_version "${release_version}")

# Basic checks on cmake
cmake_minimum_required(VERSION 3.12)
# once we move CMake to >= 3.13, we should use target_link_option in examples/sthread
# once we move CMake to >= 3.13.1, we could get rid of _Boost_STACKTRACE_BACKTRACE_HEADERS
# When updating, try to remove some cmake_policy() to see if it's OK or if it generates a warning
message(STATUS "Cmake version ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION}")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_HOME_DIRECTORY}/tools/cmake/Modules)

if(POLICY CMP0167)
  cmake_policy(SET CMP0167 NEW)
endif()

project(simgrid C CXX)

# customizable installation directories
include(GNUInstallDirs)

#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#
#     Check for the compiler        #
#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
## Request full debugging flags
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g3")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g3")

## We need a decent support of the C++17 and C11 standards
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)

if (CMAKE_C_COMPILER_ID STREQUAL "Intel" AND CMAKE_C11_EXTENSION_COMPILE_OPTION STREQUAL "-std=c11")
  set(CMAKE_C11_EXTENSION_COMPILE_OPTION "-std=gnu11")
endif()

### Check threading support
set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
find_package(Threads)

### Setup Options
include(${CMAKE_HOME_DIRECTORY}/tools/cmake/Option.cmake)

### SMPI vs. Fortran
if ((NOT DEFINED enable_smpi) OR enable_smpi)
  # First unset the compiler in case we're re-running cmake over a previous
  # configuration where it was saved as smpiff
  unset(CMAKE_Fortran_COMPILER)

  SET(SMPI_FORTRAN OFF)
  if(enable_fortran)
    enable_language(Fortran OPTIONAL)
  endif()

  if(CMAKE_Fortran_COMPILER)

    # Fortran compiler detected: save it, then replace by smpiff
    set(SMPI_Fortran_COMPILER "${CMAKE_Fortran_COMPILER}" CACHE FILEPATH "The real Fortran compiler")

	# Set flags/libs to be used in smpiff
    if(CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
      set(SMPI_Fortran_FLAGS_ "\"-fpic\" \"-ff2c\" \"-fno-second-underscore\"")
      set(SMPI_Fortran_LIBS "\"-lgfortran\"")
      set(SMPI_GFORTRAN 1)
    elseif(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
      set(SMPI_Fortran_FLAGS_ "\"-fPIC\" \"-nofor-main\"")
      set(SMPI_Fortran_LIBS "\"-lifcore\"")
      set(SMPI_IFORT 1)
    elseif(CMAKE_Fortran_COMPILER_ID MATCHES "PGI|Flang") # flang
      set(SMPI_Fortran_FLAGS_ "\"-fPIC\"")
      set(SMPI_Fortran_LIBS "")
      set(SMPI_FLANG 1)
    endif()
    set(SMPI_Fortran_FLAGS "${SMPI_Fortran_FLAGS_} ${SMPI_Fortran_FLAGS}")

    ## Request debugging flags for Fortran too
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -g")

    set(SMPI_FORTRAN ON)
  endif(CMAKE_Fortran_COMPILER)

  # Borrowed from FindSimGrid with modification because we are in tree
  macro(smpi_c_target NAME)
    target_compile_options(${NAME} PUBLIC "-include;smpi/smpi_helpers.h;-fPIC")
    target_link_options(${NAME} PUBLIC "-fPIC;-shared")
    target_link_libraries(${NAME} PUBLIC simgrid)
    target_include_directories(${NAME} PUBLIC "${CMAKE_SOURCE_DIR}/include;${CMAKE_SOURCE_DIR}/include/smpi")
  endmacro()

endif()

execute_process(COMMAND ${CMAKE_LINKER} -v OUTPUT_VARIABLE LINKER_VERSION ERROR_VARIABLE LINKER_VERSION)
string(REGEX MATCH "[0-9].[0-9]*" LINKER_VERSION "${LINKER_VERSION}")

# tesh.py needs python 3
find_package(Python3 COMPONENTS Interpreter)
if(NOT Python3_Interpreter_FOUND)
  message(FATAL_ERROR "Please install Python (version 3 or higher) to compile SimGrid.")
endif()
set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE})

SET(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

### Compute the include paths

# Only include public headers by default
include_directories(
   ${CMAKE_BINARY_DIR}/include
   ${CMAKE_HOME_DIRECTORY}/include
)

# Compute the ones that should be added when compiling the library
set(INTERNAL_INCLUDES
  ${CMAKE_BINARY_DIR}
  ${CMAKE_HOME_DIRECTORY}
  )

if(enable_smpi)
  set (INTERNAL_INCLUDES ${INTERNAL_INCLUDES} ${CMAKE_HOME_DIRECTORY}/src/smpi/include)
endif()

if(NOT CMAKE_CROSSCOMPILING AND EXISTS /usr/include/)
  set(INTERNAL_INCLUDES ${INTERNAL_INCLUDES} /usr/include/)
endif()

# library dependency cannot start with a space (CMP0004), so initialize it with something that is never deactivated.
set(SIMGRID_DEP "-lm")

### Determine the assembly flavor that we need today
set(HAVE_RAW_CONTEXTS 0)
include(CMakeDetermineSystem)
foreach(arch i686 x86_64 arm64)
  set(SIMGRID_PROCESSOR_${arch} 0)
endforeach()
IF(CMAKE_SYSTEM_PROCESSOR MATCHES ".86|AMD64|amd64")
  IF(CMAKE_SIZEOF_VOID_P EQUAL 4) # 32 bits
    message(STATUS "System processor: i686 (${CMAKE_SYSTEM_PROCESSOR}, 32 bits)")
    set(SIMGRID_PROCESSOR_i686 1)
  ELSE()
    message(STATUS "System processor: x86_64 (${CMAKE_SYSTEM_PROCESSOR}, 64 bits)")
    set(SIMGRID_PROCESSOR_x86_64 1)
  ENDIF()
  if(CMAKE_SIZEOF_VOID_P EQUAL 4 AND CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
    message(STATUS "Disable fast raw contexts on x32 ABI.")
  else()
    set(HAVE_RAW_CONTEXTS 1)
  endif()
ELSEIF(CMAKE_SYSTEM_PROCESSOR MATCHES "aarch64")
  message(STATUS "System processor: arm64 (${CMAKE_SYSTEM_PROCESSOR}, 64 bits)")
  set(SIMGRID_PROCESSOR_arm64 1)
ELSE()
  message(STATUS "System processor (${CMAKE_SYSTEM_PROCESSOR}) not explicitly accounted for")
ENDIF()

### Determine wether we use the MUSL libc, as some advanced privatization features fail with it
set(SIMGRID_HAVE_MUSL OFF)
if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  try_run(run_musl compile_musl ${CMAKE_BINARY_DIR} ${CMAKE_HOME_DIRECTORY}/tools/cmake/test_prog/prog_musl.c
    COMPILE_OUTPUT_VARIABLE compile_musl_output)

  #If can have both context
  if(NOT compile_musl)
    message(FATAL_ERROR "Error: Failed to detect whether we use the MUSL libc.\n${compile_musl_output}")
  elseif(run_musl)
    message(STATUS "MUSL libc detected.")
    set(SIMGRID_HAVE_MUSL ON)
  else()
    message(STATUS "GNU libc detected.")
  endif()
endif()

if(SIMGRID_HAVE_MUSL)
  # std::to_string fails as in https://github.com/aws/aws-sdk-cpp/issues/3299 with FORTIFY_SOURCE=2 on MUSL
  # TEMP_HACK Please remove this hack at some point
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -U_FORTIFY_SOURCE")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -U_FORTIFY_SOURCE")
elseif(enable_compile_optimizations AND (NOT (CMAKE_C_COMPILER_ID STREQUAL "Intel")))
  # But when not using MUSL, let's fortify our code if we plan to compile with -O
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FORTIFY_SOURCE=2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_FORTIFY_SOURCE=2")
endif()

include(CheckFunctionExists)
include(CheckTypeSize)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckSymbolExists)

set(HAVE_GRAPHVIZ OFF)
if(minimal-bindings)
  message(STATUS "Don't even look for graphviz, as we build minimal binding libraries.")
else()
  include(FindGraphviz)
endif()

set(SIMGRID_HAVE_NS3 OFF)
if(enable_ns3)
  include(FindNS3)
  if (SIMGRID_HAVE_NS3)
    if (NOT NS3_VERSION EQUAL "3-dev" AND NS3_VERSION VERSION_LESS "3.28")
      message(FATAL_ERROR "SimGrid needs ns-3 in version 3.28 or higher. Please upgrade or disable that cmake option.")
    endif()
    if ((NOT NS3_VERSION EQUAL "3-dev") AND NS3_VERSION VERSION_GREATER "3.41")
      # ns3 v3.42 needs C++20 because timer-impl.h uses std::remove_cvref_t
      message(STATUS "Activating C++20 for NS3 ${NS3_VERSION}")
      set_source_files_properties(src/kernel/resource/models/network_ns3.cpp
                                  PROPERTIES COMPILE_FLAGS -std=gnu++20)
      set_source_files_properties(src/kernel/resource/models/ns3/ns3_simulator.cpp
                                  PROPERTIES COMPILE_FLAGS -std=gnu++20)
    else()
      message(STATUS "ns3 v${NS3_VERSION} does not require C++20.")
    endif()
    set(SIMGRID_HAVE_NS3 ON)
    set(SIMGRID_DEP "${SIMGRID_DEP} ${NS3_LIBRARIES}")
  else()
    message(FATAL_ERROR "Cannot find ns-3. Please install it (apt-get install ns3 libns3-dev) or disable that cmake option")
  endif()
endif()

### Check for Eigen library
if ((NOT DEFINED EIGEN3_HINT) OR (NOT EIGEN3_HINT STRLESS_EQUAL "OFF"))
  set(SIMGRID_HAVE_EIGEN3 OFF)
  find_package (Eigen3 3.3 CONFIG
                HINTS ${EIGEN3_HINT})
  if (Eigen3_FOUND)
    set(SIMGRID_HAVE_EIGEN3 ON)
    message(STATUS "Found Eigen3: ${EIGEN3_INCLUDE_DIR}")
    include_directories(${EIGEN3_INCLUDE_DIR})
    if ("3.3.4" VERSION_EQUAL EIGEN3_VERSION_STRING AND CMAKE_COMPILER_IS_GNUCC)
      message(STATUS "Avoid build error of Eigen3 v3.3.4 using -Wno-error=int-in-bool-context")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=int-in-bool-context")
    endif()
  else()
    message(STATUS "Disabling model BMF because Eigen3 was not found. If it's installed, use EIGEN3_HINT to hint cmake about the location of Eigen3Config.cmake")
  endif()
  mark_as_advanced(Eigen3_DIR)
else()
  message(STATUS "Disabling Eigen3 as requested by the user (EIGEN3_HINT is set to 'OFF')")
endif()

# Check for our JSON dependency
set(SIMGRID_HAVE_JSON 0)
find_package(nlohmann_json 3.7
             HINTS ${nlohmann_json_HINT})
if (nlohmann_json_FOUND)
  set(SIMGRID_HAVE_JSON 1)
  if (NOT NLOHMANN_JSON_INCLUDE_DIR)
    get_target_property(NLOHMANN_JSON_INCLUDE_DIR nlohmann_json::nlohmann_json INTERFACE_INCLUDE_DIRECTORIES)
    list(REMOVE_DUPLICATES NLOHMANN_JSON_INCLUDE_DIR)
  else()
    include_directories(${NLOHMANN_JSON_INCLUDE_DIR})
  endif()
  message(STATUS "Found nlohmann_json: ${NLOHMANN_JSON_INCLUDE_DIR}")
endif()
mark_as_advanced(nlohmann_json_DIR)

set(HAVE_PAPI OFF)
if(enable_smpi_papi)
  include(FindPAPI)
  if (NOT HAVE_PAPI)
    message(FATAL_ERROR "Cannot find PAPI. Please install it (apt-get install papi-tools libpapi-dev) or disable PAPI bindings.")
  endif()
endif()
mark_as_advanced(PAPI_PREFIX)

if(CMAKE_VERSION VERSION_LESS 3.20)
  message(STATUS "cmake is too old to test for C++23 stacks (v${CMAKE_VERSION})")
  set(HAVE_STD_STACKTRACE 0) # CMake does not know about C++23, we cannot test it on the compiler
else()
  try_compile(HAVE_STD_STACKTRACE ${CMAKE_BINARY_DIR}
    SOURCES ${CMAKE_HOME_DIRECTORY}/tools/cmake/test_prog/prog_stdstacktrace.cpp
    CXX_STANDARD 23
    CXX_STANDARD_REQUIRED 23
    LINK_LIBRARIES stdc++exp
    OUTPUT_VARIABLE compile_stacktrace_output)
  if(HAVE_STD_STACKTRACE)
    message(STATUS "C++23 stacks: found. Switching to C++23.")
    set(CMAKE_CXX_STANDARD 23)
  else()
    message(STATUS "C++23 stacks: NOT FOUND. Sticking to C++17.\n${compile_stacktrace_output}")
  endif()
endif()

# But we do need the core of Boost
# cmake before 3.13.1 does not know about stacktrace components. Fix it.
# Usable components: https://www.boost.org/doc/libs/1_65_1/doc/html/stacktrace/configuration_and_build.html
set(_Boost_STACKTRACE_HEADERS           "boost/stacktrace.hpp")
set(_Boost_STACKTRACE_BACKTRACE_HEADERS "boost/stacktrace.hpp")
set(_Boost_STACKTRACE_ADDR2LINE_HEADERS "boost/stacktrace.hpp")

  if(minimal-bindings) # When we want a minimal python or Java library, don't even search for boost optional components

=== examples/c/CMakeLists.txt ===
# Regular examples: with only one source and tested with all factories
######################################################################

foreach(x
        actor-create actor-daemon actor-exiting actor-join actor-kill actor-lifetime actor-migrate actor-stacksize
        actor-suspend actor-yield
        activityset-testany activityset-waitall activityset-waitallfor activityset-waitany
        app-masterworker app-token-ring
        comm-pingpong comm-wait
        cloud-capping cloud-masterworker cloud-migration cloud-simple
        dht-pastry
        exec-async exec-basic exec-dvfs exec-remote
        energy-exec energy-exec-ptask energy-vm
        io-disk-raw io-file-remote io-file-system
        platform-failures platform-properties
        plugin-host-load
        synchro-semaphore)
  add_executable       (c-${x} EXCLUDE_FROM_ALL ${x}/${x}.c)
  target_link_libraries(c-${x} simgrid)
  set_target_properties(c-${x} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${x})
  add_dependencies(tests c-${x})

  set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/${x}/${x}.tesh)
  set(examples_src  ${examples_src}  ${CMAKE_CURRENT_SOURCE_DIR}/${x}/${x}.c)
endforeach()

# Multi-files examples
######################
# bittorrent example
add_executable       (c-app-bittorrent EXCLUDE_FROM_ALL app-bittorrent/app-bittorrent.c app-bittorrent/bittorrent-peer.c app-bittorrent/tracker.c)
target_link_libraries(c-app-bittorrent simgrid)
set_target_properties(c-app-bittorrent PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/app-bittorrent)
add_dependencies(tests c-app-bittorrent)

foreach (file app-bittorrent bittorrent-peer tracker)
  set(examples_src  ${examples_src}  ${CMAKE_CURRENT_SOURCE_DIR}/app-bittorrent/${file}.c  ${CMAKE_CURRENT_SOURCE_DIR}/app-bittorrent/${file}.h)
endforeach()

# Chainsend example

add_executable       (c-app-chainsend EXCLUDE_FROM_ALL app-chainsend/chainsend.c app-chainsend/broadcaster.c
                      app-chainsend/peer.c)
target_link_libraries(c-app-chainsend simgrid)
set_target_properties(c-app-chainsend PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/app-chainsend)
add_dependencies(tests c-app-chainsend)

foreach (file chainsend broadcaster peer)
  set(examples_src  ${examples_src}  ${CMAKE_CURRENT_SOURCE_DIR}/app-chainsend/${file}.c)
endforeach()
set(examples_src ${examples_src} ${CMAKE_CURRENT_SOURCE_DIR}/app-chainsend/chainsend.h)

#DHT-Kademlia
add_executable       (c-dht-kademlia EXCLUDE_FROM_ALL dht-kademlia/dht-kademlia.c dht-kademlia/node.c dht-kademlia/routing_table.c dht-kademlia/message.c dht-kademlia/answer.c)
target_link_libraries(c-dht-kademlia simgrid)
set_target_properties(c-dht-kademlia PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/dht-kademlia)
add_dependencies(tests c-dht-kademlia)

foreach (file answer node routing_table message)
  set(examples_src  ${examples_src}  ${CMAKE_CURRENT_SOURCE_DIR}/dht-kademlia/${file}.c  ${CMAKE_CURRENT_SOURCE_DIR}/dht-kademlia/${file}.h)
endforeach()

# Add all extra files to the archive
####################################

set(tesh_files    ${tesh_files} ${CMAKE_CURRENT_SOURCE_DIR}/app-bittorrent/app-bittorrent.tesh
                                ${CMAKE_CURRENT_SOURCE_DIR}/app-chainsend/app-chainsend.tesh
                                ${CMAKE_CURRENT_SOURCE_DIR}/app-masterworker/app-masterworker-multicore.tesh
                                ${CMAKE_CURRENT_SOURCE_DIR}/app-masterworker/app-masterworker-vivaldi.tesh
                                ${CMAKE_CURRENT_SOURCE_DIR}/dht-kademlia/dht-kademlia.tesh
                                PARENT_SCOPE)
set(bin_files     ${bin_files} ${CMAKE_CURRENT_SOURCE_DIR}/app-bittorrent/generate.py
                               ${CMAKE_CURRENT_SOURCE_DIR}/dht-kademlia/generate.py
                               ${CMAKE_CURRENT_SOURCE_DIR}/dht-pastry/generate.py                          PARENT_SCOPE)
set(examples_src  ${examples_src} ${CMAKE_CURRENT_SOURCE_DIR}/dht-kademlia/common.h
                                  ${CMAKE_CURRENT_SOURCE_DIR}/dht-kademlia/dht-kademlia.c                  PARENT_SCOPE)
set(xml_files     ${xml_files} ${CMAKE_CURRENT_SOURCE_DIR}/actor-create/actor-create_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/actor-lifetime/actor-lifetime_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/actor-yield/actor-yield_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/app-bittorrent/app-bittorrent_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/app-chainsend/app-chainsend_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/app-masterworker/app-masterworker_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/app-masterworker/app-masterworker-multicore_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/app-masterworker/app-masterworker-vivaldi_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/comm-pingpong/comm-pingpong_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/comm-wait/comm-wait_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/comm-wait/comm-wait2_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/comm-wait/comm-wait3_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/comm-wait/comm-wait4_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/dht-kademlia/dht-kademlia_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/dht-pastry/dht-pastry_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/io-file-remote/io-file-remote_d.xml
                               ${CMAKE_CURRENT_SOURCE_DIR}/platform-properties/platform-properties_d.xml
                               PARENT_SCOPE)

foreach(x
        actor-create actor-daemon actor-exiting actor-join actor-kill actor-lifetime actor-migrate actor-stacksize
        actor-suspend actor-yield
        activityset-testany activityset-waitall activityset-waitallfor activityset-waitany
        app-bittorrent app-chainsend app-masterworker app-token-ring
        comm-pingpong comm-wait
        cloud-capping  cloud-masterworker cloud-migration cloud-simple
        dht-kademlia dht-pastry
        exec-async exec-basic exec-dvfs exec-remote
        energy-exec energy-exec-ptask energy-vm
        io-disk-raw io-file-remote io-file-system
        platform-failures platform-properties
        plugin-host-load
        synchro-semaphore)
  ADD_TESH(c-${x} --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms
                  --setenv bindir=${CMAKE_BINARY_DIR}/examples/c/${x}
                  --cd ${CMAKE_HOME_DIRECTORY}/examples/c/${x}
                  ${CMAKE_HOME_DIRECTORY}/examples/c/${x}/${x}.tesh)
endforeach()

ADD_TESH_FACTORIES(app-masterworker-multicore   "*"
                                                --setenv srcdir=${CMAKE_HOME_DIRECTORY}/examples/c/app-masterworker
                                                --setenv bindir=${CMAKE_BINARY_DIR}/examples/c/app-masterworker
                                                --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms
                                               ${CMAKE_HOME_DIRECTORY}/examples/c/app-masterworker/app-masterworker-multicore.tesh)
ADD_TESH_FACTORIES(app-masterworker-vivaldi     "*"
                                                --setenv srcdir=${CMAKE_HOME_DIRECTORY}/examples/c/app-masterworker
                                                --setenv bindir=${CMAKE_BINARY_DIR}/examples/c/app-masterworker
                                                --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms
                                                ${CMAKE_HOME_DIRECTORY}/examples/c/app-masterworker/app-masterworker-vivaldi.tesh)

ADD_TESH_FACTORIES(c-app-bittorrent-parallel "raw" --cfg contexts/nthreads:4 ${CONTEXTS_SYNCHRO}
                                             --setenv bindir=${CMAKE_BINARY_DIR}/examples/c/app-bittorrent
                                             --setenv srcdir=${CMAKE_HOME_DIRECTORY}/examples/platforms
                                             --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms
                                             --cd ${CMAKE_HOME_DIRECTORY}/examples/c/app-bittorrent app-bittorrent.tesh)

ADD_TESH_FACTORIES(c-dht-kademlia-parallel "*" --cfg contexts/nthreads:4 ${CONTEXTS_SYNCHRO}
                                           --setenv bindir=${CMAKE_BINARY_DIR}/examples/c/dht-kademlia
                                           --setenv srcdir=${CMAKE_HOME_DIRECTORY}/examples/c/dht-kademlia
                                           --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms
                                           ${CMAKE_HOME_DIRECTORY}/examples/c/dht-kademlia/dht-kademlia.tesh)

=== examples/cpp/CMakeLists.txt ===
# Regular examples: with only one source and tested with all factories by default
#################################################################################
### Define the examples' specificities

set(_app-bittorrent_sources app-bittorrent/s4u-bittorrent.cpp app-bittorrent/s4u-bittorrent.hpp
                            app-bittorrent/s4u-peer.cpp app-bittorrent/s4u-peer.hpp
                            app-bittorrent/s4u-tracker.cpp app-bittorrent/s4u-tracker.hpp)
set(_dht-chord_sources    dht-chord/s4u-dht-chord.cpp dht-chord/s4u-dht-chord.hpp dht-chord/s4u-dht-chord-node.cpp)
set(_dht-kademlia_sources dht-kademlia/s4u-dht-kademlia.cpp dht-kademlia/s4u-dht-kademlia.hpp
                          dht-kademlia/node.cpp dht-kademlia/node.hpp
                          dht-kademlia/routing_table.cpp dht-kademlia/routing_table.hpp
                          dht-kademlia/answer.cpp dht-kademlia/answer.hpp dht-kademlia/message.hpp)

set(_actor-stacksize_factories "^thread") # Threads ignore modifications of the stack size

# The maestro-set example only works for threads
set(_maestro-set_factories "thread")

if(SIMGRID_HAVE_MC)
  # These tests timeout with threads, not sure why
  foreach(example mc-bugged1 mc-bugged2 mc-failing-assert mc-electric-fence)
    set(_${example}_factories "^thread") # Timeout
    add_dependencies(tests-mc s4u-${example})
  endforeach()

  if(enable_coverage)
    foreach (example mc-bugged1 mc-bugged2 mc-electric-fence mc-failing-assert)
      ADD_TEST(cover-${example} ${CMAKE_CURRENT_BINARY_DIR}/${example}/s4u-${example} ${CMAKE_HOME_DIRECTORY}/examples/platforms/model_checker_platform.xml)
    endforeach()
  endif()
else()
  foreach (example mc-bugged1 mc-bugged2  mc-centralized-mutex mc-failing-assert mc-electric-fence)
    set(_${example}_disable 1)
  endforeach()
endif()

# Hijack some regular tests to run them on top of the MC
foreach (example synchro-barrier synchro-mutex synchro-semaphore)
  set(tesh_files ${tesh_files} ${CMAKE_CURRENT_SOURCE_DIR}/${example}/s4u-mc-${example}.tesh)

  if (SIMGRID_HAVE_MC)
    ADD_TESH(s4u-mc-${example}
              --setenv bindir=${CMAKE_CURRENT_BINARY_DIR}/${example}
              --setenv libdir=${CMAKE_BINARY_DIR}/lib
              --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms
              --setenv srcdir=${CMAKE_CURRENT_SOURCE_DIR}/${example}
              --cd ${CMAKE_CURRENT_SOURCE_DIR}/${example}
              ${CMAKE_HOME_DIRECTORY}/examples/cpp/${example}/s4u-mc-${example}.tesh)

    add_dependencies(tests-mc s4u-${example})
  endif()
endforeach()

if (SIMGRID_HAVE_MC)
  # Dependency on the regular tests
  foreach(example mc-centralized-mutex)
    add_dependencies(tests-mc s4u-${example})
  endforeach()
endif()

if(NOT HAVE_GRAPHVIZ)
  set(_dag-from-dot_disable 1)
  set(_dag-from-dot-simple_disable 1)
endif()

if (NOT SIMGRID_HAVE_JSON)
  set(_dag-from-json-simple_disable 1)
endif()

if(SIMGRID_HAVE_NS3)
  if(NS3_VERSION VERSION_GREATER_EQUAL 3.37)
    set(_network-ns3_teshfile         ${CMAKE_HOME_DIRECTORY}/examples/cpp/network-ns3/s4u-network-ns3-timed.tesh)
    set(tesh_files    ${tesh_files}   ${CMAKE_HOME_DIRECTORY}/examples/cpp/network-ns3/s4u-network-ns3-notime.tesh)
  else()
    set(_network-ns3_teshfile         ${CMAKE_HOME_DIRECTORY}/examples/cpp/network-ns3/s4u-network-ns3-notime.tesh)
    set(tesh_files    ${tesh_files}   ${CMAKE_HOME_DIRECTORY}/examples/cpp/network-ns3/s4u-network-ns3-timed.tesh)
  endif()

foreach (example network-ns3 network-ns3-wifi)
  add_dependencies(tests-ns3 s4u-${example})
endforeach()

else()
  # Even if ns3 is not found, we need to override the teshfile name and make sure that everything gets included in the archive
  set(_network-ns3_teshfile         ${CMAKE_HOME_DIRECTORY}/examples/cpp/network-ns3/s4u-network-ns3-notime.tesh)
  set(tesh_files    ${tesh_files}   ${CMAKE_HOME_DIRECTORY}/examples/cpp/network-ns3/s4u-network-ns3-timed.tesh)

  foreach (example network-ns3 network-ns3-wifi)
    set(_${example}_disable 1)
  endforeach()
endif()

# Deal with each example

foreach (example activityset-testany activityset-waitany activityset-waitall activityset-waitallfor
                 actor-create actor-daemon actor-exiting actor-join actor-kill
                 actor-lifetime actor-migrate actor-suspend actor-yield actor-stacksize
                 app-bittorrent app-chainsend app-token-ring
                 battery-chiller-solar battery-connector battery-degradation battery-simple battery-energy
                 chiller-simple
                 comm-pingpong comm-ready comm-suspend comm-wait comm-waituntil
                 comm-dependent comm-host2host comm-failure comm-throttling
                 cloud-capping cloud-migration cloud-simple
                 dag-comm dag-from-json-simple dag-from-dax-simple dag-from-dax dag-from-dot-simple dag-from-dot dag-failure dag-io dag-scheduling dag-simple dag-tuto
                 dht-chord dht-kademlia
                 energy-exec energy-boot energy-link energy-vm energy-exec-ptask energy-wifi
                 engine-filtering engine-run-partial
                 exec-async exec-basic exec-dvfs exec-remote exec-suspend exec-waitfor exec-dependent exec-unassigned
                 exec-ptask-multicore exec-ptask-multicore-latency exec-cpu-nonlinear exec-cpu-factors exec-failure exec-threads
                 maestro-set
                 mc-bugged1 mc-bugged2 mc-centralized-mutex mc-electric-fence mc-failing-assert
                 mess-wait
                 network-ns3 network-ns3-wifi network-wifi
                 io-async io-priority io-degradation io-file-system io-file-remote io-disk-raw io-dependent
                 task-dispatch task-io task-microservice task-parallelism task-simple task-storm task-switch-host task-variable-load
                 solar-panel-simple
                 platform-comm-serialize platform-failures platform-profile platform-properties
                 plugin-host-load plugin-vm-load plugin-jbod plugin-link-load plugin-prodcons
                 replay-comm replay-io
                 routing-get-clusters
                 synchro-barrier synchro-condition-variable synchro-condition-variable-waituntil synchro-mutex synchro-semaphore
                 clusters-multicpu network-factors network-nonlinear)

  # Use default source file unless specified otherwise
  if(NOT DEFINED _${example}_sources)
    set(_${example}_sources ${example}/s4u-${example}.cpp)
  endif()

  # Use default tesh file unless specified otherwise
  if(NOT DEFINED _${example}_teshfile)
    set(_${example}_teshfile ${CMAKE_HOME_DIRECTORY}/examples/cpp/${example}/s4u-${example}.tesh)
  endif()

  if(NOT DEFINED _${example}_disable)
    add_executable       (s4u-${example} EXCLUDE_FROM_ALL ${_${example}_sources})
    add_dependencies     (tests s4u-${example})
    add_dependencies     (s4u-${example} platf_cpp)
    target_link_libraries(s4u-${example} simgrid)
    set_target_properties(s4u-${example} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${example})

    # Use default factories unless specified otherwise
    if(NOT DEFINED _${example}_factories)
      set(_${example}_factories "*")
    endif()
#    message("Factories of ${example}: ${_${example}_factories}")

    ADD_TESH_FACTORIES(s4u-${example} "${_${example}_factories}"
                                      --setenv bindir=${CMAKE_CURRENT_BINARY_DIR}/${example}
                                      --setenv libdir=${CMAKE_BINARY_DIR}/lib
                                      --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms
                                      --setenv srcdir=${CMAKE_CURRENT_SOURCE_DIR}/${example}
                                      --cd ${CMAKE_CURRENT_SOURCE_DIR}/${example}
                                      ${_${example}_teshfile})
  else()
    message(STATUS "Example ${example} disabled, thus not compiled.")
    unset(_${example}_disable)
  endif()

  set(tesh_files    ${tesh_files}    ${_${example}_teshfile})
  foreach(file ${_${example}_sources})
    set(examples_src  ${examples_src} ${CMAKE_CURRENT_SOURCE_DIR}/${file})
  endforeach()

  unset(_${example}_factories)
  unset(_${example}_sources)
  unset(_${example}_teshfile)
endforeach()


# Specific examples
###################

# MASTERWORKERS EXAMPLE
foreach(variant fun class)
  add_executable       (s4u-app-masterworkers-${variant} EXCLUDE_FROM_ALL app-masterworkers/s4u-app-masterworkers-${variant}.cpp)
  target_link_libraries(s4u-app-masterworkers-${variant} simgrid)
  set_target_properties(s4u-app-masterworkers-${variant} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/app-masterworkers)
  add_dependencies(tests s4u-app-masterworkers-${variant})

  set(examples_src  ${examples_src}  ${CMAKE_CURRENT_SOURCE_DIR}/app-masterworkers/s4u-app-masterworkers-${variant}.cpp)
endforeach()
set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/app-masterworkers/s4u-app-masterworkers.tesh)

# The tests the parallel variant of of DHTs, but only on Linux since other platforms are fragile with that regard

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  foreach(example app-bittorrent app-masterworkers
                  dht-chord dht-kademlia
                  )
    ADD_TESH_FACTORIES(s4u-${example}-parallel "*" --cfg contexts/nthreads:4 ${CONTEXTS_SYNCHRO}
                                               --setenv bindir=${CMAKE_CURRENT_BINARY_DIR}/${example}
                                               --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms
                                               --cd ${CMAKE_CURRENT_SOURCE_DIR}/${example}
                                               ${CMAKE_HOME_DIRECTORY}/examples/cpp/${example}/s4u-${example}.tesh)
  endforeach()
endif()

# Examples not accepting factories
##################################

foreach (example exec-ptask trace-categories trace-masterworkers trace-platform trace-process-migration
                 trace-host-user-variables trace-link-user-variables trace-route-user-variables)
  add_executable       (s4u-${example} EXCLUDE_FROM_ALL ${example}/s4u-${example}.cpp)
  target_link_libraries(s4u-${example} simgrid)
  set_target_properties(s4u-${example} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${example})
  add_dependencies(tests s4u-${example})

  set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/${example}/s4u-${example}.tesh)
  set(examples_src  ${examples_src}  ${CMAKE_CURRENT_SOURCE_DIR}/${example}/s4u-${example}.cpp)

  ADD_TESH(s4u-${example} --setenv bindir=${CMAKE_CURRENT_BINARY_DIR}/${example}
                          --setenv srcdir=${CMAKE_CURRENT_SOURCE_DIR}/${example}
                          --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms
                          --cd ${CMAKE_CURRENT_BINARY_DIR}/${example}
                          ${CMAKE_HOME_DIRECTORY}/examples/cpp/${example}/s4u-${example}.tesh)
endforeach()

if (NOT enable_memcheck)
  ADD_TESH(debug-breakpoint --setenv bindir=${CMAKE_CURRENT_BINARY_DIR}/comm-pingpong
                            --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms
                            ${CMAKE_CURRENT_SOURCE_DIR}/comm-pingpong/debug-breakpoint.tesh)
endif()

# Add all extra files to the archive
####################################
set(examples_src  ${examples_src}    PARENT_SCOPE)
set(tesh_files    ${tesh_files}   ${CMAKE_CURRENT_SOURCE_DIR}/comm-pingpong/debug-breakpoint.tesh  PARENT_SCOPE)
set(xml_files     ${xml_files}    ${CMAKE_CURRENT_SOURCE_DIR}/actor-create/s4u-actor-create_d.xml
                                  ${CMAKE_CURRENT_SOURCE_DIR}/actor-lifetime/s4u-actor-lifetime_d.xml
                                  ${CMAKE_CURRENT_SOURCE_DIR}/app-bittorrent/s4u-app-bittorrent_d.xml
                                  ${CMAKE_CURRENT_SOURCE_DIR}/app-masterworkers/s4u-app-masterworkers_d.xml

=== examples/java/CMakeLists.txt ===
if(SIMGRID_HAVE_JAVA)
  if(${Java_VERSION} VERSION_GREATER_EQUAL "24.0.0")
    set(javac_args "--enable-native-access=ALL-UNNAMED")
  else()
    message(STATUS "Java version is ${Java_VERSION}, no need to specifically enable the access to native libs.")
  endif()
endif()

if(NOT HAVE_GRAPHVIZ)
  set(_dag_from_dot_disable 1)
  set(_dag_from_dot_simple_disable 1)
endif()
if (NOT SIMGRID_HAVE_JSON)
  set(_dag_from_json_simple_disable 1)
endif()

# io_dependent io_file_system io_file_remote: need a plugin
# exec_failure: needs state profiles
foreach (example activityset_awaitall activityset_awaitallfor activityset_awaitany activityset_testany
                 actor_create actor_daemon actor_exiting actor_join actor_kill
                 actor_lifetime actor_migrate actor_suspend actor_yield
                 cloud_migration cloud_simple #cloud_capping
                 dag_comm dag_failure dag_from_dax_simple dag_from_dax dag_from_dot_simple dag_from_dot dag_from_json_simple dag_io dag_scheduling dag_simple dag_tuto
                 energy_boot energy_exec energy_exec_ptask energy_link energy_vm energy_wifi
                 exec_async exec_awaitfor exec_basic exec_cpu_factors exec_dependent exec_dvfs exec_threads exec_ptask exec_ptask_multicore exec_ptask_multicore_latency exec_remote exec_suspend exec_unassigned
#                 exec_cpu_nonlinear
                 comm_await comm_awaituntil comm_dependent comm_failure comm_host2host comm_pingpong comm_ready comm_suspend comm_throttling
                 io_async io_disk_raw io_priority # io_degradation 
                 mess_await
                 platform_comm_serialize # platform_failures  platform_profile  platform_properties
                 synchro_barrier synchro_condition_variable synchro_condition_variable_awaituntil synchro_mutex synchro_semaphore
                 #task_dispatch  task_io  task_microservice  task_parallelism  task_simple  task_storm  task_switch_host  task_variable_load
                 plugin_host_load plugin_link_load
                 )
  
  # Use default source file unless specified otherwise
  if(NOT DEFINED _${example}_sources)
    set(_${example}_sources ${CMAKE_CURRENT_SOURCE_DIR}/${example}/${example}.java)
  endif()
  # Use default tesh file unless specified otherwise
  if(NOT DEFINED _${example}_teshfile)
    set(_${example}_teshfile ${CMAKE_CURRENT_SOURCE_DIR}/${example}/${example}.java.tesh)
  endif()

  if(SIMGRID_HAVE_JAVA AND (NOT DEFINED _${example}_disable))
    add_jar(java-${example} SOURCES ${_${example}_sources}
            INCLUDE_JARS simgrid_jar
            ENTRY_POINT ${example}
            OUTPUT_NAME ${example}
            OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/${example_dir})
    add_dependencies(tests-java java-${example})

    if(APPLE)
      set(LIB_PATH DYLD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib:$ENV{DYLD_LIBRARY_PATH})
    else()
      set(LIB_PATH LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/lib:$ENV{LD_LIBRARY_PATH})
    endif()
    ADD_TESH(java-${example} --setenv LD_PRELOAD=$ENV{SAN_LIBS} --setenv ${LIB_PATH} --setenv LC_CTYPE=C --setenv javacmd="${Java_JAVA_EXECUTABLE} -Xcheck:jni ${javac_args}" --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms --setenv srcdir=${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/${example}/${example}.java.tesh)
  endif()

  set(examples_src  ${examples_src}  ${_${example}_sources})
  set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/${example}/${example}.java.tesh)
endforeach()

set(examples_src  ${examples_src}                                                                          PARENT_SCOPE)
set(tesh_files    ${tesh_files}                                                                            PARENT_SCOPE)
set(xml_files     ${xml_files}    ${CMAKE_CURRENT_SOURCE_DIR}/actor_lifetime/actor_lifetime_d.xml
                                  ${CMAKE_CURRENT_SOURCE_DIR}/actor_create/actor_create_d.xml
                                  ${CMAKE_CURRENT_SOURCE_DIR}/dag_scheduling/Montage_25.xml
                  PARENT_SCOPE)
set(txt_files     ${txt_files}    ${CMAKE_CURRENT_SOURCE_DIR}/dag_from_dax/simple_dax_with_cycle.xml
                                  ${CMAKE_CURRENT_SOURCE_DIR}/dag_from_dax/smalldax.xml
                                  ${CMAKE_CURRENT_SOURCE_DIR}/dag_from_dax_simple/dag.xml
                                  ${CMAKE_CURRENT_SOURCE_DIR}/dag_from_dot/dag.dot
                                  ${CMAKE_CURRENT_SOURCE_DIR}/dag_from_dot/dag_with_cycle.dot
                                  ${CMAKE_CURRENT_SOURCE_DIR}/dag_from_dot_simple/dag.dot
                                  ${CMAKE_CURRENT_SOURCE_DIR}/dag_from_json_simple/dag.json
                                  #${CMAKE_CURRENT_SOURCE_DIR}/replay_comm/s4u-replay-comm-split-p0.txt
                                  #${CMAKE_CURRENT_SOURCE_DIR}/replay_comm/s4u-replay-comm-split-p1.txt
                                  #${CMAKE_CURRENT_SOURCE_DIR}/replay_comm/s4u-replay-comm.txt
                                  #${CMAKE_CURRENT_SOURCE_DIR}/replay_io/s4u-replay-io.txt
                    PARENT_SCOPE)

=== examples/sthread/CMakeLists.txt ===
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# Regular pthread examples: test the interceptor of the pthread interface
#########################################################################

foreach(x
        cond-timedwait_ok exit
        mutex-simple mutex-recursive
      	producer-consumer)

  if(enable_sthread)
    add_executable       (pthread-${x} EXCLUDE_FROM_ALL pthread-${x}.c)
    set_target_properties(pthread-${x} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    target_link_libraries(pthread-${x} PRIVATE Threads::Threads)

    add_dependencies(tests pthread-${x})
    ADD_TESH(pthread-${x} --setenv libdir=${CMAKE_BINARY_DIR}/lib --cd ${CMAKE_BINARY_DIR}/examples/sthread ${CMAKE_CURRENT_SOURCE_DIR}/pthread-${x}.tesh)

    if(SIMGRID_HAVE_MC)
      add_dependencies(tests-mc pthread-${x})
      ADD_TESH(pthread-mc-${x} --setenv libdir=${CMAKE_BINARY_DIR}/lib --cd ${CMAKE_BINARY_DIR}/examples/sthread ${CMAKE_CURRENT_SOURCE_DIR}/pthread-mc-${x}.tesh)
    endif()
  endif()

  set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/pthread-${x}.tesh
                                     ${CMAKE_CURRENT_SOURCE_DIR}/pthread-mc-${x}.tesh)
  set(examples_src  ${examples_src}  ${CMAKE_CURRENT_SOURCE_DIR}/pthread-${x}.c)

endforeach()

# Regular pthread examples that may deadlock: test sthread + MC in that case
############################################################################

foreach(x
        mutex-simpledeadlock)

  if(enable_sthread)

    add_executable       (pthread-${x} EXCLUDE_FROM_ALL pthread-${x}.c)
    set_target_properties(pthread-${x} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    target_link_libraries(pthread-${x} PRIVATE Threads::Threads)

    if(SIMGRID_HAVE_MC)
      add_dependencies(tests-mc pthread-${x})
      ADD_TESH(pthread-mc-${x} --setenv libdir=${CMAKE_BINARY_DIR}/lib --cd ${CMAKE_BINARY_DIR}/examples/sthread ${CMAKE_CURRENT_SOURCE_DIR}/pthread-mc-${x}.tesh)
    endif()
  endif()

  set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/pthread-mc-${x}.tesh)
  set(examples_src  ${examples_src}  ${CMAKE_CURRENT_SOURCE_DIR}/pthread-${x}.c)

endforeach()

# MPI + pthread tests in C (with or without error)
###################################################

set(_mutex-simpledeadlock_failing ON)

foreach(x
        mutex-simple mutex-simpledeadlock)

  if(enable_sthread AND enable_smpi)
    add_executable       (smpi-${x} EXCLUDE_FROM_ALL smpi-${x}.c)
    set_target_properties(smpi-${x} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    target_link_libraries(smpi-${x} PRIVATE Threads::Threads)
    smpi_c_target(smpi-${x})

    add_dependencies(tests smpi-${x})
    if(NOT DEFINED _${x}_failing)
      ADD_TESH(smpi-${x} --setenv libdir=${CMAKE_BINARY_DIR}/lib --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms --cd ${CMAKE_BINARY_DIR}/examples/sthread ${CMAKE_CURRENT_SOURCE_DIR}/smpi-${x}.tesh)
    endif()
    
    if(SIMGRID_HAVE_MC)
      add_dependencies(tests-mc smpi-${x})
      ADD_TESH_FACTORIES(smpi-mc-${x} "^thread" --setenv libdir=${CMAKE_BINARY_DIR}/lib --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms --cd ${CMAKE_BINARY_DIR}/examples/sthread --setenv "extraparam=--cfg=model-check/no-fork:off" ${CMAKE_CURRENT_SOURCE_DIR}/smpi-mc-${x}.tesh)
      ADD_TESH_FACTORIES(smpi-mc-${x}  "thread" --setenv libdir=${CMAKE_BINARY_DIR}/lib --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms --cd ${CMAKE_BINARY_DIR}/examples/sthread --setenv "extraparam=--cfg=model-check/no-fork:on"  ${CMAKE_CURRENT_SOURCE_DIR}/smpi-mc-${x}.tesh)
    endif()
  endif()
  
  if(NOT DEFINED _${x}_failing)
    set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/smpi-${x}.tesh)
  endif()
  set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/smpi-mc-${x}.tesh)
  set(examples_src  ${examples_src}  ${CMAKE_CURRENT_SOURCE_DIR}/smpi-${x}.c)
  unset(_${x}_failing)

endforeach()

# C++ tests with sthread+MC that live in their own directory
########################################################
foreach(example
        stdobject)

  if(${enable_sthread})

    add_executable       (${example} EXCLUDE_FROM_ALL ${CMAKE_CURRENT_SOURCE_DIR}/${example}/${example}.cpp)
    set_target_properties(${example} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    target_link_libraries(${example} PRIVATE Threads::Threads)
    set_target_properties(${example} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${example})

    if(SIMGRID_HAVE_MC)
      add_dependencies(tests-mc ${example})
      ADD_TESH_FACTORIES(sthread-mc-${example} "^thread" --setenv libdir=${CMAKE_BINARY_DIR}/lib --cd ${CMAKE_BINARY_DIR}/examples/sthread/${example} --setenv "extraparam=--cfg=model-check/no-fork:off" ${CMAKE_CURRENT_SOURCE_DIR}/${example}/${example}.tesh)
      ADD_TESH_FACTORIES(sthread-mc-${example}  "thread" --setenv libdir=${CMAKE_BINARY_DIR}/lib --cd ${CMAKE_BINARY_DIR}/examples/sthread/${example} --setenv "extraparam=--cfg=model-check/no-fork:on"  ${CMAKE_CURRENT_SOURCE_DIR}/${example}/${example}.tesh)
    endif()
  endif()

  set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/${example}/${example}.tesh)
  set(examples_src  ${examples_src}  ${CMAKE_CURRENT_SOURCE_DIR}/${example}/${example}.cpp)
endforeach()

# Add all extra files to the archive
####################################

set(tesh_files    ${tesh_files}     PARENT_SCOPE)
set(bin_files     ${bin_files}      PARENT_SCOPE)
set(examples_src  ${examples_src}   PARENT_SCOPE)
set(xml_files     ${xml_files}      PARENT_SCOPE)

=== teshsuite/kernel/CMakeLists.txt ===
foreach(x context-defaults stack-overflow)
  add_executable       (${x}  EXCLUDE_FROM_ALL ${x}/${x}.cpp)
  target_link_libraries(${x}  simgrid)
  set_target_properties(${x}  PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${x})
  set_property(TARGET ${x} APPEND PROPERTY INCLUDE_DIRECTORIES "${INTERNAL_INCLUDES}")
  add_dependencies(tests ${x})

  set(teshsuite_src ${teshsuite_src} ${CMAKE_CURRENT_SOURCE_DIR}/${x}/${x}.cpp)
endforeach()

## Add the tests for stack-overflow
set(tesh_files    ${tesh_files} ${CMAKE_CURRENT_SOURCE_DIR}/stack-overflow/stack-overflow.tesh)
if (NOT enable_memcheck AND NOT enable_address_sanitizer AND NOT enable_thread_sanitizer)
  ADD_TESH_FACTORIES(stack-overflow   "^thread" --setenv bindir=${CMAKE_BINARY_DIR}/teshsuite/kernel/stack-overflow --setenv srcdir=${CMAKE_HOME_DIRECTORY} --cd ${CMAKE_HOME_DIRECTORY}/teshsuite/kernel/stack-overflow stack-overflow.tesh)
endif()

## Add the tests for context-default
foreach (factory raw thread boost)
  set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/context-defaults/factory_${factory}.tesh)
endforeach()
# Ensure that we have the right default setting for the context factory
IF(HAVE_RAW_CONTEXTS)
  ADD_TESH(tesh-kernel-context-default --setenv bindir=${CMAKE_BINARY_DIR}/teshsuite/kernel/context-defaults --cd ${CMAKE_HOME_DIRECTORY}/teshsuite/kernel/context-defaults factory_raw.tesh)
ELSEIF(HAVE_BOOST_CONTEXTS)
  ADD_TESH(tesh-kernel-context-default --setenv bindir=${CMAKE_BINARY_DIR}/teshsuite/kernel/context-defaults --cd ${CMAKE_HOME_DIRECTORY}/teshsuite/kernel/context-defaults factory_boost.tesh)
ELSE()
  ADD_TESH(tesh-kernel-context-default --setenv bindir=${CMAKE_BINARY_DIR}/teshsuite/kernel/context-defaults --cd ${CMAKE_HOME_DIRECTORY}/teshsuite/kernel/context-defaults factory_thread.tesh)
ENDIF()
# Ensure that we get what we want when specifying the context factory on the command line
foreach (factory raw thread boost)
  string (TOUPPER have_${factory}_contexts VARNAME)
  if (${factory} STREQUAL "thread" OR ${VARNAME})
    # Cannot use ADD_TESH() here since ${factory} is part of the tesh filename
    ADD_TESH(tesh-kernel-factory-${factory} --cfg contexts/factory:${factory} --setenv bindir=${CMAKE_BINARY_DIR}/teshsuite/kernel/context-defaults --cd ${CMAKE_HOME_DIRECTORY}/teshsuite/kernel/context-defaults factory_${factory}.tesh)
  endif()
endforeach()


# Pack the files in the archive
set(teshsuite_src ${teshsuite_src}  PARENT_SCOPE)
set(tesh_files    ${tesh_files}     PARENT_SCOPE)
set(xml_files     ${xml_files}      PARENT_SCOPE)

=== teshsuite/mc/CMakeLists.txt ===

foreach(x random-bug mutex-handling)

  if(NOT DEFINED ${x}_sources)
    set(${x}_sources ${x}/${x}.cpp)
  endif()

  if(NOT DEFINED ${x}_disable)
    add_executable       (${x}  EXCLUDE_FROM_ALL ${${x}_sources})
    target_link_libraries(${x}  simgrid)
    set_target_properties(${x}  PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${x})
    set_property(TARGET ${x} APPEND PROPERTY INCLUDE_DIRECTORIES "${INTERNAL_INCLUDES}")
    target_compile_options(${x} PRIVATE ${CMAKE_C_DEBUG_FLAGS})
    add_dependencies(tests-mc ${x})
  endif()

  set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/${x}/${x}.tesh)

  foreach(file ${${x}_sources})
    set(teshsuite_src  ${teshsuite_src} ${CMAKE_CURRENT_SOURCE_DIR}/${file})
  endforeach()

  unset(${x}_sources)
  unset(${x}_disable)

endforeach()

add_executable       (without-mutex-handling EXCLUDE_FROM_ALL mutex-handling/mutex-handling.cpp)
target_link_libraries(without-mutex-handling simgrid)
set_target_properties(without-mutex-handling PROPERTIES COMPILE_FLAGS -DDISABLE_THE_MUTEX=1)
set_target_properties(without-mutex-handling PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/mutex-handling)
add_dependencies(tests-mc without-mutex-handling)

ADD_TESH(mc-random-bug-replay                --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms --setenv bindir=${CMAKE_BINARY_DIR}/teshsuite/mc/random-bug --cd ${CMAKE_HOME_DIRECTORY}/teshsuite/mc/random-bug random-bug-replay.tesh)
IF(SIMGRID_HAVE_MC)
  ADD_TESH(tesh-mc-mutex-handling-dpor         --setenv bindir=${CMAKE_BINARY_DIR}/teshsuite/mc/mutex-handling --setenv srcdir=${CMAKE_HOME_DIRECTORY} --cd ${CMAKE_HOME_DIRECTORY}/teshsuite/mc/mutex-handling mutex-handling.tesh --cfg=model-check/reduction:dpor)
  ADD_TESH(tesh-mc-without-mutex-handling-dpor --setenv bindir=${CMAKE_BINARY_DIR}/teshsuite/mc/mutex-handling --setenv srcdir=${CMAKE_HOME_DIRECTORY} --cd ${CMAKE_HOME_DIRECTORY}/teshsuite/mc/mutex-handling without-mutex-handling.tesh --cfg=model-check/reduction:dpor)
  ADD_TESH(mc-random-bug                       --setenv platfdir=${CMAKE_HOME_DIRECTORY}/examples/platforms --setenv bindir=${CMAKE_BINARY_DIR}/teshsuite/mc/random-bug --cd ${CMAKE_HOME_DIRECTORY}/teshsuite/mc/random-bug random-bug.tesh)
ENDIF()

if(enable_coverage)
  ADD_TEST(cover-mc-mutex-handling ${CMAKE_CURRENT_BINARY_DIR}/mutex-handling/mutex-handling ${CMAKE_HOME_DIRECTORY}/examples/platforms/small_platform.xml)
endif()

foreach(x
            simple_barrier_ok              simple_barrier_deadlock
            simple_barrier_with_threads_ok simple_barrier_with_threads_deadlock

            simple_cond_ok                 simple_cond_deadlock
            simple_cond_broadcast_ok       simple_cond_broadcast_deadlock

#            simple_cond_broadcast_with_semaphore_ok 
      	     simple_cond_broadcast_with_semaphore_deadlock1  simple_cond_broadcast_with_semaphore_deadlock2

             simple_mutex_ok simple_mutex_deadlock
             simple_mutex_with_threads_ok simple_mutex_with_threads_deadlock

             simple_semaphore_deadlock simple_semaphores_deadlock
             simple_semaphores_ok
             simple_semaphores_with_threads_ok simple_semaphores_with_threads_deadlock
	     
             simple_threads_ok

             barber_shop_ok             barber_shop_deadlock
             philosophers_semaphores_ok philosophers_semaphores_deadlock
             philosophers_mutex_ok      philosophers_mutex_deadlock
             producer_consumer_ok       producer_consumer_deadlock    
             
             # philosophers_spurious_deadlock # infinite no-op loop             
             # producer_consumer_spurious_nok # infinite no-op loop
             )

  set(teshsuite_src  ${teshsuite_src} ${CMAKE_CURRENT_SOURCE_DIR}/mcmini/${x}.c)
  set(tesh_files     ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/mcmini/${x}.tesh)

  if(${enable_sthread} AND ${enable_testsuite_McMini} AND SIMGRID_HAVE_MC)
    add_executable       (mcmini-${x}  EXCLUDE_FROM_ALL mcmini/${x}.c)         
    set_target_properties(mcmini-${x}  PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/mcmini)
    target_link_libraries(mcmini-${x}  PRIVATE Threads::Threads)
    add_dependencies(tests-mc mcmini-${x})

    ADD_TESH(mc-mini-${x} --setenv libdir=${CMAKE_BINARY_DIR}/lib --setenv bindir=${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/mcmini/${x}.tesh)
  endif()
endforeach()
if(${enable_testsuite_McMini} AND (NOT ${enable_sthread}))
  message(STATUS "McMini tests cannot be executed when sthread is disabled.")
endif()
if(${enable_testsuite_McMini} AND (NOT SIMGRID_HAVE_MC))
  message(STATUS "McMini tests cannot be executed when MC is disabled.")
endif()

set(probe_deadlock_disable 1)
set(probe_ok_disable 1)
foreach(x iprobe_ok iprobe_nok probe_deadlock probe_ok)
  if(NOT DEFINED ${x}_disable)
    set(${x}_disable 0)
  endif()
  if(SIMGRID_HAVE_MC AND enable_smpi AND NOT ${${x}_disable})
    add_executable       (mpi_${x}  EXCLUDE_FROM_ALL mpi/${x}.c)
    smpi_c_target(mpi_${x})
    set_target_properties(mpi_${x}  PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    add_dependencies(tests-mc mpi_${x})

    ADD_TESH(mc-mpi-${x} --setenv libdir=${CMAKE_BINARY_DIR}/lib --setenv srcdir=${CMAKE_CURRENT_SOURCE_DIR} --setenv bindir=${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/mpi/${x}.tesh)
  endif()
  unset(${x}_disable)

  set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/mpi/${x}.tesh)
  set(teshsuite_src ${teshsuite_src} ${CMAKE_CURRENT_SOURCE_DIR}/mpi/${x}.c)
endforeach()


set(teshsuite_src  ${teshsuite_src}                                                                        PARENT_SCOPE)
set(tesh_files     ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/random-bug/random-bug-replay.tesh
                                    ${CMAKE_CURRENT_SOURCE_DIR}/mutex-handling/without-mutex-handling.tesh PARENT_SCOPE)

=== teshsuite/platforms/CMakeLists.txt ===
add_executable       (flatifier EXCLUDE_FROM_ALL flatifier.cpp)
target_link_libraries(flatifier  simgrid)
set_target_properties(flatifier  PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
set_property(TARGET flatifier APPEND PROPERTY INCLUDE_DIRECTORIES "${INTERNAL_INCLUDES}")
add_dependencies(tests flatifier)

add_library(asymetric_nested_zones SHARED asymetric_nested_zones.cpp)
target_link_libraries(asymetric_nested_zones simgrid)
add_dependencies(tests asymetric_nested_zones)

set(teshsuite_src ${teshsuite_src}  ${CMAKE_CURRENT_SOURCE_DIR}/flatifier.cpp
                                    ${CMAKE_CURRENT_SOURCE_DIR}/asymetric_nested_zones.cpp
                                    PARENT_SCOPE)
set(tesh_files    ${tesh_files}     ${CMAKE_CURRENT_SOURCE_DIR}/bogus_two_hosts_asymetric.tesh
                                    ${CMAKE_CURRENT_SOURCE_DIR}/bogus_missing_gateway.tesh
                                    ${CMAKE_CURRENT_SOURCE_DIR}/flatifier.tesh
                                    PARENT_SCOPE)
set(xml_files     ${xml_files}      ${CMAKE_CURRENT_SOURCE_DIR}/four_hosts_floyd.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/two_hosts_multi_hop.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/host_attributes.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/link_attributes.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/one_cluster_multicore.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/one_cluster_splitduplex.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/one_cluster_router_id.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/one_cluster.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/properties.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/test_of_is_router.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/three_hosts_non_symmetric_route.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/two_clusters_one_name.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/two_clusters_router_id.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/two_clusters.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/bogus_missing_src_gateway.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/bogus_missing_dst_gateway.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/bogus_two_hosts_asymetric.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/two_hosts_one_link_splitduplex.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/two_hosts_one_link.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/cluster_dragonfly_noncontiguous_rad.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/cluster_fat_tree_noncontiguous_rad.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/cluster_torus_noncontiguous_rad.xml
                                    ${CMAKE_CURRENT_SOURCE_DIR}/Dijkstra.xml
                                    PARENT_SCOPE)
set(txt_files     ${txt_files}      ${CMAKE_CURRENT_SOURCE_DIR}/carol.fail
                                    ${CMAKE_CURRENT_SOURCE_DIR}/bob.trace
                                    ${CMAKE_CURRENT_SOURCE_DIR}/erin.avail
                                    ${CMAKE_CURRENT_SOURCE_DIR}/link.bw
                                    ${CMAKE_CURRENT_SOURCE_DIR}/link.fail
                                    ${CMAKE_CURRENT_SOURCE_DIR}/link.lat
                                    PARENT_SCOPE)

ADD_TESH(tesh-platform-flatifier --setenv bindir=${CMAKE_BINARY_DIR}/teshsuite/platforms --setenv srcdir=${CMAKE_HOME_DIRECTORY} --setenv libdir=${CMAKE_BINARY_DIR}/lib --setenv CMAKE_SHARED_LIBRARY_SUFFIX=${CMAKE_SHARED_LIBRARY_SUFFIX} --cd ${CMAKE_HOME_DIRECTORY}/teshsuite/platforms flatifier.tesh)

if(enable_debug)
  # these tests need assertions
  ADD_TESH(tesh-parser-bogus-symmetric         --setenv bindir=${CMAKE_BINARY_DIR}/teshsuite/platforms --cd ${CMAKE_HOME_DIRECTORY}/teshsuite/platforms ${CMAKE_HOME_DIRECTORY}/teshsuite/platforms/bogus_two_hosts_asymetric.tesh)
  ADD_TESH(tesh-parser-bogus-missing-gw        --setenv bindir=${CMAKE_BINARY_DIR}/teshsuite/platforms --cd ${CMAKE_HOME_DIRECTORY}/teshsuite/platforms ${CMAKE_HOME_DIRECTORY}/teshsuite/platforms/bogus_missing_gateway.tesh)
endif()

=== tools/docker/Makefile ===
default:
	@echo "Existing Targets:"
	@echo "   make build-deps -> build an image with all possible SimGrid dependencies"
	@echo "   make stable     -> build the latest stable version of SimGrid (with SMPI w/o MC)"
	@echo "   make unstable   -> build the git version of SimGrid (with SMPI, w/o MC)"
	@echo "   make tuto-s4u   -> build all what you need to take the S4U tutorial"
	@echo "   make tuto-smpi  -> build all what you need to take the SMPI tutorial"
	@echo "   make tuto-mc    -> build the git version of SimGrid (with SMPI and MC)"
	@echo "   make all        -> build all but stable (ie, build-deps unstable tuto-s4u tuto-smpi)"
	@echo "   make push       -> push all images to the cloud"
	@echo "All our images are based on debian:testing"
	@echo "Also possible: DOCKER_EXTRA=--no-cache make unstable"

all: build-deps unstable tuto-s4u tuto-smpi tuto-mc

stable:
	# docker build -f Dockerfile.stable --build-arg DLURL=/simgrid/simgrid/-/archive/v3.28/simgrid-v3.28.tar.gz -t simgrid/stable:latest -t simgrid/stable:v3.25 . |tee stable.log
	export last_tag=$$(wget https://framagit.org/simgrid/simgrid/tags 2>/dev/null -O - | grep /simgrid/simgrid/-/tags/v | head -n1  | sed 's/[^>]*>//' | sed 's/<.*//'); \
 	echo "DLURL=/simgrid/simgrid/-/archive/$${last_tag}/simgrid-$${last_tag}.tar.gz";\
	docker build -f Dockerfile.stable \
	         --build-arg DLURL=/simgrid/simgrid/-/archive/$${last_tag}/simgrid-$${last_tag}.tar.gz \
		 -t simgrid/stable:latest \
                 -t simgrid/stable:$${last_tag} \
		 $(DOCKER_EXTRA) \
                 . | tee stable.log

unstable:
	docker build -f Dockerfile.unstable \
	         -t simgrid/unstable:latest \
                 -t simgrid/unstable:$$(date --iso-8601) \
		 $(DOCKER_EXTRA) \
                 . | tee unstable.log

build-deps:
	docker build -f Dockerfile.build-deps \
	         -t simgrid/build-deps:latest \
                 -t simgrid/build-deps:$$(date --iso-8601) \
		 $(DOCKER_EXTRA) \
                 . | tee build-deps.log

tuto-mc:
	docker build -f Dockerfile.tuto-mc \
	         -t simgrid/tuto-mc:latest \
                 -t simgrid/tuto-mc:$$(date --iso-8601) \
		 $(DOCKER_EXTRA) \
                 . | tee tuto-mc.log
mc-slim:
	docker build -f Dockerfile.mc-slim \
	         -t simgrid/mc-slim:latest \
                 -t simgrid/mc-slim:$$(date --iso-8601) \
		 $(DOCKER_EXTRA) \
                 . | tee mc-slim.log

build-deps-stable:
	docker build -f Dockerfile.build-deps-stable \
	         -t simgrid/build-deps-stable:latest \
                 -t simgrid/build-deps-stable:$$(date --iso-8601) \
		 $(DOCKER_EXTRA) \
                 . | tee build-deps-stable.log

tuto-s4u:
	docker build -f Dockerfile.tuto-s4u \
	         -t simgrid/tuto-s4u:latest \
                 -t simgrid/tuto-s4u:$$(date --iso-8601) \
		 $(DOCKER_EXTRA) \
                 . | tee tuto-s4u.log

tuto-smpi:
	docker build -f Dockerfile.tuto-smpi \
	         -t simgrid/tuto-smpi:latest \
                 -t simgrid/tuto-smpi:$$(date --iso-8601) \
		 $(DOCKER_EXTRA) \
                 . | tee tuto-smpi.log

push:
	docker push --all-tags simgrid/build-deps
	docker push --all-tags simgrid/stable
	docker push --all-tags simgrid/unstable
	docker push --all-tags simgrid/tuto-s4u
	docker push --all-tags simgrid/tuto-smpi
	docker push --all-tags simgrid/tuto-mc

=== tools/tesh/CMakeLists.txt ===
configure_file("${CMAKE_HOME_DIRECTORY}/tools/tesh/tesh.py"
  "${CMAKE_BINARY_DIR}/bin/tesh" @ONLY IMMEDIATE)


foreach(x setenv set-output-ignore set-output-sort set-return set-timeout background basic bg-basic bg-set-signal
          catch-all-bg-output catch-return catch-signal catch-timeout catch-timeout-output catch-wrong-output cd color
          ignore-regexp IO-bigsize IO-broken-pipe IO-orders)
  set(tesh_files  ${tesh_files} ${CMAKE_CURRENT_SOURCE_DIR}/${x}.tesh)
  if(NOT enable_memcheck)
    ADD_TESH(tesh-self-${x} --setenv bindir=${CMAKE_BINARY_DIR}/bin ${CMAKE_HOME_DIRECTORY}/tools/tesh/${x}.tesh)
  endif()
endforeach()

set(tesh_files ${tesh_files}                                                                               PARENT_SCOPE)
set(bin_files  ${bin_files}  ${CMAKE_CURRENT_SOURCE_DIR}/tesh.py ${CMAKE_CURRENT_SOURCE_DIR}/generate_tesh PARENT_SCOPE)

=== examples/smpi/replay_multiple/CMakeLists.txt ===
if(enable_smpi)
  include_directories(BEFORE "${CMAKE_HOME_DIRECTORY}/include/smpi")

  add_executable       (replay_multiple EXCLUDE_FROM_ALL replay_multiple.cpp)
  target_link_libraries(replay_multiple simgrid)
  ADD_TESH(smpi-replay-multiple --setenv srcdir=${CMAKE_CURRENT_SOURCE_DIR} --setenv bindir=${CMAKE_CURRENT_BINARY_DIR} --cd ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/replay_multiple.tesh)
  add_dependencies(tests replay_multiple)
endif()

set(txt_files     ${txt_files}     ${CMAKE_CURRENT_SOURCE_DIR}/generate_multiple_deployment.py
                                   ${CMAKE_CURRENT_SOURCE_DIR}/description_file
                                   ${CMAKE_CURRENT_SOURCE_DIR}/README
                                   ${CMAKE_CURRENT_SOURCE_DIR}/smpi_replay.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace0.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace1.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace2.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace3.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace4.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace5.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace6.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace7.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace8.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace9.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace10.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace11.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace12.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace13.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace14.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace15.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace16.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace17.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace18.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace19.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace20.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace21.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace22.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace23.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace24.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace25.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace26.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace27.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace28.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace29.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace30.txt
                                   ${CMAKE_CURRENT_SOURCE_DIR}/ti_traces_32_1/ti_trace31.txt  PARENT_SCOPE)
set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/replay_multiple.tesh           PARENT_SCOPE)
set(examples_src  ${examples_src}  ${CMAKE_CURRENT_SOURCE_DIR}/replay_multiple.cpp            PARENT_SCOPE)

=== examples/smpi/smpi_s4u_masterworker/CMakeLists.txt ===
if(enable_smpi)
  include_directories(BEFORE "${CMAKE_HOME_DIRECTORY}/include/smpi")

  add_executable       (masterworker_mailbox_smpi EXCLUDE_FROM_ALL masterworker_mailbox_smpi.cpp)
  target_link_libraries(masterworker_mailbox_smpi simgrid)
  ADD_TESH_FACTORIES(smpi-s4u-masterworker "*" --setenv srcdir=${CMAKE_HOME_DIRECTORY}/examples/smpi/smpi_s4u_masterworker --cd ${CMAKE_BINARY_DIR}/examples/smpi/smpi_s4u_masterworker ${CMAKE_HOME_DIRECTORY}/examples/smpi/smpi_s4u_masterworker/s4u_smpi.tesh)
  add_dependencies(tests masterworker_mailbox_smpi)
endif()

set(tesh_files    ${tesh_files}    ${CMAKE_CURRENT_SOURCE_DIR}/s4u_smpi.tesh                            PARENT_SCOPE)
set(xml_files     ${xml_files}     ${CMAKE_CURRENT_SOURCE_DIR}/deployment_masterworker_mailbox_smpi.xml PARENT_SCOPE)
set(examples_src  ${examples_src}  ${CMAKE_CURRENT_SOURCE_DIR}/masterworker_mailbox_smpi.cpp            PARENT_SCOPE)

=== debian/changelog ===
simgrid (4.1-1) unstable; urgency=medium

  * New upstream release: Breaking the seal (v4.0 was not the final release).
    - Allow one to unseal netzones to modify the platform even after
      the simulation start.
    - The model-checker can now report memory race conditions (see tutorial).
    - Pip builds should now work out of the box.
    - (+ the usual bug fixes overall, and improvements to the
       Java/Python bindings).

  * Run wrap-and-sort -astkb
  * d/control: bump Standards-version to 4.7.2.

 -- Martin Quinson <mquinson@debian.org>  Tue, 11 Nov 2025 23:27:12 +0100

=== debian/control ===
Source: simgrid
Section: science
Priority: optional
Maintainer: Martin Quinson <mquinson@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 chrpath,
 cmake,
# Needed for the Java bindings
 default-jdk-headless,
 gfortran,
 javahelper,
 libboost-context-dev,
 libboost-dev,
 libboost-stacktrace-dev,
# Needed to build the doc
# python3-breathe,
# python-sphinx-rtd-theme,
# python3-sphinx,
 libeigen3-dev,
 libns3-dev,
 nlohmann-json3-dev,
# Needed for the detection of ns-3:
 pkgconf,
 pybind11-dev,
 python3-all,
# Needed for the python bindings
 python3-dev,
# valgrind is missing on armel
 valgrind [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x],
Standards-Version: 4.7.2
Homepage: https://simgrid.org/
Vcs-Git: https://salsa.debian.org/debian/simgrid.git
Vcs-Browser: https://salsa.debian.org/debian/simgrid

Package: libsimgrid4.1
Provides:
 ${t64:Provides},
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libsimgrid4.1 (<< ${source:Version}),
 simgrid (<< 3.11),
Replaces:
 libsimgrid4.1,
 simgrid (<< 3.11),
Description: Toolkit for scalable simulation of distributed applications
 SimGrid is a toolkit that provides core functionalities for the simulation of
 distributed applications in heterogeneous distributed environments. SimGrid
 can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
 simulator, or a mix of all of them. The typical use-cases of SimGrid include
 heuristic evaluation, application prototyping, and real application
 development and tuning.
 .
 This package contains the dynamic libraries and runtime.

#Package: simgrid-doc
#Architecture: all
#Multi-Arch: foreign
#Section: doc
#Depends: ${misc:Depends},
#  libjs-jquery,
#  libjs-jquery-ui,
#  libjs-mathjax,
#Breaks: simgrid (<< 3.11)
#Replaces: simgrid (<< 3.11)
#Description: Documentation for the SimGrid Toolkit
# SimGrid is a toolkit that provides core functionalities for the simulation of
# distributed applications in heterogeneous distributed environments. SimGrid
# can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
# simulator, or a mix of all of them. The typical use-cases of SimGrid include
# heuristic evaluation, application prototyping, and real application
# development and tuning.
# .
# This package contains the documentation for both the C and the Java
# version of SimGrid.

Package: libsimgrid-dev
Architecture: any
Section: libdevel
Depends:
 libboost-dev,
 libsimgrid4.1 (= ${binary:Version}),
 ${misc:Depends},
 ${perl:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 gcc,
 make,
# simgrid-doc (>= ${source:Version})
Conflicts:
 simgrid,
Replaces:
 simgrid,
Provides:
 simgrid,
Description: Development files for the SimGrid Toolkit
 SimGrid is a toolkit that provides core functionalities for the simulation of
 distributed applications in heterogeneous distributed environments. SimGrid
 can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
 simulator, or a mix of all of them. The typical use-cases of SimGrid include
 heuristic evaluation, application prototyping, and real application
 development and tuning.
 .
 This package contains the development files that you need to build
 your own simulator on top of SimGrid (header files and scripts),
 for C, C++ or Fortran.

Package: python3-simgrid
Architecture: any
Section: python
Depends:
 libsimgrid4.1 (>= ${source:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Provides:
 ${python3:Provides},
#Versions: ${python3:Versions}
#Recommends: simgrid-doc (>= ${source:Version})
Breaks:
 simgrid (<< 3.11),
Replaces:
 simgrid (<< 3.11),
Suggests:
 python3,
Description: Python3 bindings for the SimGrid Toolkit
 SimGrid is a toolkit that provides core functionalities for the simulation of
 distributed applications in heterogeneous distributed environments. SimGrid
 can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
 simulator, or a mix of all of them. The typical use-cases of SimGrid include
 heuristic evaluation, application prototyping, and real application
 development and tuning.
 .
 This package contains what you need to use SimGrid from the Python
 programming language.

Package: simgrid-java
Architecture: any
Section: java
Depends:
 libsimgrid4.1 (>= ${source:Version}),
 ${java:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ${java:Recommends},
Provides:
 ${java:Provides},
Description: Java bindings for the SimGrid Toolkit
 SimGrid is a toolkit that provides core functionalities for the simulation of
 distributed applications in heterogeneous distributed environments. SimGrid
 can be used as a Grid simulator, a P2P simulator, a Cloud simulator, a MPI
 simulator, or a mix of all of them. The typical use-cases of SimGrid include
 heuristic evaluation, application prototyping, and real application
 development and tuning.
 .
 This package contains what you need to use SimGrid from the Java
 programming language.
